<?php
/**
 * Copyright © 2018 Filoblu S.r.l. All rights reserved.
 */

namespace FiloBlu\Flow\Block\Adminhtml\System\Config;

/**
 * Renderer for Event Configuration
 */

class Specialactions extends \Magento\Config\Block\System\Config\Form\Field\FieldArray\AbstractFieldArray
{
    
    /**
     * @var \Magento\Sales\Model\ResourceModel\Order\Status\Collection
     */
    protected $collection;

    /**
     * Statuses per state array
     *
     * @var array
     */
    protected $stateStatuses;

    /**
     * @var Status
     */
    protected $orderStatusFactory;

    /**
     * @var \Magento\Sales\Model\ResourceModel\Order\Status\CollectionFactory
     */
    protected $orderStatusCollectionFactory;

    /**
     * @var \Magento\Payment\Api\PaymentMethodListInterface
     */
    protected $methodList;

    /**
     * @var Payment Methods
     */
    protected $paymentMethodRenderer = null;

    /**
     * Specialactions constructor.
     * @param \Magento\Backend\Block\Template\Context $context
     * @param array $data
     */
    public function __construct(
        \Magento\Backend\Block\Template\Context $context, 
        array $data = []
    ) {
        parent::__construct($context, $data);
    }

    /**
     * Enable the "Add after" button or not
     *
     * @var bool
     */
    protected $_addAfter = true;


    /**
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    protected function _prepareToRender()
    {


        $this->addColumn('name', array(
            'label' => __('Name')
        ));

        $eventTypeBlock=$this->getLayout()->createBlock('Magento\Framework\View\Element\Html\Select')
                        ->setId($this->_getCellInputElementId('<%- _id %>','executed_on'))
                        ->setName($this->_getCellInputElementName('executed_on'))
                        ->setClass('select')
                        ->setOptions(
                            array(
                                ['value' => '', 'label' => __('-- Please Select --')],
                                ['value' => 'product', 'label' => __('Product')],
                                ['value' => 'attribute', 'label' => __('Attribute')]
                            )
                        );

        $this->addColumn('executed_on', array(
            'label' => __('Executed On'),
            'renderer' => $eventTypeBlock
        ));

        $this->addColumn('priority', array(
            'label' => __('Priority')
        ));

        $this->_addAfter = false;
        $this->_addButtonLabel = __('Add new special action config');
    }

 
}
